%define ALD_Ver		2.0

Name:         faad2

License:      GPL
Summary:      C library and frontend for decoding MPEG2/4 AAC
Version:      2.9.2
Release:      0
URL:        http://www.audiocoding.com/

#https://github.com/knik0/faad2
#https://wiki.videolan.org/FAAD2_and_FAAC/
#http://download.sourceforge.net/faad/%{name}-%{version}.tar.gz

Source: %{name}-%{version}.tar.xz

%define BUILD_xmms_plugin 0

%define DestDir		/Multimedia
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
FAAD 2 is a LC, MAIN and LTP profile, MPEG2 and MPEG-4 AAC decoder, completely
written from scratch. FAAD 2 is licensed under the GPL.
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Requires:     %{name} = %{version}
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package bin
Summary:      faad  Process an Advanced Audio Codec stream
Requires:     %{name} = %{version}
%description bin
faad  Process an Advanced Audio Codec stream
#-------------------------------
%package DRM
Summary:     Libraries for Allow decoding of Digital Radio Mondiale (DRM)
%description DRM
Allow decoding of Digital Radio Mondiale (DRM)

#-------------------------------
%if %BUILD_xmms_plugin
%package xmms-plugin
Summary:      MP4 xmms plugin
%description xmms-plugin
MP4 xmms plugin
%endif

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

./bootstrap

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables"

CFLAGS="$OPTFLAGS -std=gnu99"
CXXFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections"

%configure \
	--disable-static \
	--enable-shared \
	--disable-libtool-lock \
	&>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export  PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
rm $RPM_BUILD_ROOT%{_libdir}/*.la

cp AUTHORS COPYING README $RPM_BUILD_ROOT%{docdir}

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_libdir}/libfaad.so.*
%{docdir}

%files devel
%{_includedir}
%{_libdir}/libfaad.so
%{_libdir}/pkgconfig

%files bin
%{_bindir}
%{_mandir}

%files DRM
%{_libdir}/libfaad_drm.*
